from cpl_core.logging import LoggerABC
from cpl_discord.command import DiscordCommandABC
from cpl_discord.service import DiscordBotServiceABC
from cpl_translation import TranslatePipe
from discord.ext import commands
from discord.ext.commands import Context

from bot_core.abc.client_utils_service_abc import ClientUtilsServiceABC
from bot_core.abc.message_service_abc import MessageServiceABC


class PingCommand(DiscordCommandABC):

    def __init__(
            self,
            logger: LoggerABC,
            message_service: MessageServiceABC,
            bot: DiscordBotServiceABC,
            client_utils: ClientUtilsServiceABC,
            translate: TranslatePipe
    ):
        DiscordCommandABC.__init__(self)

        self._logger = logger
        self._message_service = message_service
        self._bot = bot
        self._client_utils = client_utils
        self._t = translate

        self._logger.trace(__name__, f'Loaded command service: {type(self).__name__}')

    @commands.command()
    @commands.guild_only()
    async def ping(self, ctx: Context):
        self._logger.debug(__name__, f'Received command ping {ctx}')
        self._client_utils.received_command(ctx.guild.id)
        await self._message_service.send_ctx_msg(ctx, self._t.transform('modules.base.pong'))
        self._logger.trace(__name__, f'Finished ping command')
